Skip to main content

api.getReactiveState()

Description

Gets the state object with the reactive properties of the Grid

Usage

api.getReactiveState(): object;

Returns

The method returns an object with the following parameters:

  { 
columns: array, // an array with columns data
data: array, // an array with data for the table
dynamic: object, // an object with the number of rows in a dynamic dataset
editor: object,// an object with data for the open editor
filter: (obj: any) => boolean, // the filtering function; the filter-rows action handler
scroll: object, // on object with the scroll configuration
selected: string | number, // the id of the selected row
selectedRows: array, // an object with the ids of the selected rows
sizes: object, // an object with the table sizes configuration
sort: object, // an object with the sorting configuration
split: number, // the number of frozen columns
tree: boolean, // tree structure state
flatData: array // actual data;in case of tree structure,it's a plain dataset with the "level" marker to specify each item's level in hierarchy
}

The Grid properties detailed description you can find here: Grid properties overview.

Example

To get the current value from the Store, add $ before the variable:

const { data, columns } = getData();

export default function App() {
const api = useRef(null);

if (api.current) {
api.current.getReactiveState().selected.subscribe(val => {
console.log(val); // outputs the currently selected row id
});
}

return (
<Grid data={data} columns={columns} api={api} />
);
}

Related articles:

Skip to main content

api.getReactiveState()

Description

Gets the state object with the reactive properties of the Grid

Usage

api.getReactiveState(): object;

Returns

The method returns an object with the following parameters:

{
columns: array, // an array with columns data
data: array, // an array with data for the table
dynamic: object, // an object with the number of rows in a dynamic dataset
editor: object, // an object with data for the open editor
scroll: object, // an object with the scroll configuration
scrollTop: number, // current vertical scroll position in pixels
scrollLeft: number, // current horizontal scroll position in pixels
search: object, // an object with the current search configuration
selectedRows: array, // an array with the ids of the selected rows
sizes: object, // an object with the table sizes configuration
sortMarks: object, // an object with the sorting configuration
split: object, // an object with the number of frozen columns (left/right)
tree: boolean, // tree structure state
history: object, // shows the number of operations for each undo/redo action
flatData: array // actual data; in case of the tree structure, it's a plain dataset with the "level" marker to specify each item's level in hierarchy
filterValues: object;
}

The Grid properties detailed description you can find here: Grid properties overview.

State-only properties

flatData, history, scrollTop, and scrollLeft are the state-only properties, which means that they cannot be provided with the widget properties.

scrollTop

scrollTop is the current vertical scroll position in pixels. Its initial value is 0. It is updated as the user scrolls the grid and can be set programmatically via the scroll-to action.

scrollLeft

scrollLeft is the current horizontal scroll position in pixels. Its initial value is 0. It is updated as the user scrolls the grid and can be set programmatically via the scroll-to action.

flatData

The flatData parameters are the same as data but in case of the tree structure it becomes a plain dataset with the next parameters to specify each item's level in hierarchy:

  • level - an item's level in hierarchy
  • parent - an Id of the parent item
  • count - the number of child items inside the parent item (set to 0 in case of none)

history

history is an object with the number of operations for each undo/redo action:

history: {
undo: number,
redo: number,
};

Example

To get the current value from the reactive state, use .value to access the ref:

<script setup>
import { Grid } from "@svar-ui/vue-grid";
import { getData } from "./common/data";
import { ref } from "vue";
const { data, columns } = getData();

const rSelected = ref(null);

function init(api){
rSelected.value = api.getReactiveState().selectedRows;
console.log(rSelected.value); // outputs the currently selected array of rows ids
}
</script>

<template>
<Grid :data="data" :columns="columns" :init="init" />
</template>

Related articles: